## org.apache.commons.collections.bidimap
Class AbstractBidiMapDecorator

    java.lang.Object
      org.apache.commons.collections.map.AbstractMapDecorator
          org.apache.commons.collections.bidimap.AbstractBidiMapDecorator

All Implemented Interfaces:
  java.util.Map, BidiMap, IterableMap

Direct Known Subclasses:
  AbstractOrderedBidiMapDecorator, UnmodifiableBidiMap

    public abstract class AbstractBidiMapDecorator

extends AbstractMapDecorator
implements BidiMap

Provides a base decorator that enables additional functionality to be added to a BidiMap via decoration.

Methods are forwarded directly to the decorated map.

This implementation does not perform any special processing with the map views. Instead it simply returns the set/collection from the wrapped map. This may be undesirable, for example if you are trying to write a validating implementation it would provide a loophole around the validation. But, you might want that loophole, so this class is kept simple.

Since:
  Commons Collections 3.0
Version:
  $Revision: 646777 $ $Date: 2008-04-10 13:33:15 +0100 (Thu, 10 Apr 2008) $
Author:
  Stephen Colebourne

Nested Class Summary

Nested classes/interfaces inherited from interface java.util.Map
`java.util.Map.Entry`

Field Summary

Fields inherited from class org.apache.commons.collections.map.AbstractMapDecorator
`map`

Constructor Summary
`protected` `AbstractBidiMapDecorator(BidiMap map)` Constructor that wraps (not copies).

Method Summary
`protected BidiMap` `getBidiMap()` Gets the map being decorated.
`java.lang.Object` `getKey(java.lang.Object value)` Gets the key that is currently mapped to the specified value.
`BidiMap` `inverseBidiMap()` Gets a view of this map where the keys and values are reversed.
`MapIterator` `mapIterator()` Obtains a `MapIterator` over the map.
`java.lang.Object` `removeValue(java.lang.Object value)` Removes the key-value pair that is currently mapped to the specified value (optional operation).

Methods inherited from class org.apache.commons.collections.map.AbstractMapDecorator
`clear, containsKey, containsValue, entrySet, equals, get, getMap, hashCode, isEmpty, keySet, put, putAll, remove, size, toString, values`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.apache.commons.collections.BidiMap
`put`

Methods inherited from interface java.util.Map
`clear, containsKey, containsValue, entrySet, equals, get, hashCode, isEmpty, keySet, putAll, remove, size, values`

Constructor Detail

### AbstractBidiMapDecorator

    protected AbstractBidiMapDecorator(BidiMap map)

  Constructor that wraps (not copies).

  Parameters:
    `map` - the map to decorate, must not be null
  Throws:
    `java.lang.IllegalArgumentException` - if the collection is null

Method Detail

### getBidiMap

    protected BidiMap getBidiMap()

  Gets the map being decorated.

  Returns:
    the decorated map

### mapIterator

    public MapIterator mapIterator()

  Description copied from interface: `BidiMap`
  Obtains a `MapIterator` over the map.

  A map iterator is an efficient way of iterating over maps. It does not require that the map is stored using Map Entry objects which can increase performance.

       BidiMap map = new DualHashBidiMap();
       MapIterator it = map.mapIterator();
       while (it.hasNext()) {
         Object key = it.next();
         Object value = it.getValue();
         it.setValue("newValue");
       }

  Specified by:
    `mapIterator` in interface `BidiMap`
  Specified by:
    `mapIterator` in interface `IterableMap`
  Returns:
    a map iterator

### getKey

    public java.lang.Object getKey(java.lang.Object value)

  Description copied from interface: `BidiMap`
  Gets the key that is currently mapped to the specified value.

  If the value is not contained in the map, `null` is returned.

  Implementations should seek to make this method perform equally as well as `get(Object)`.

  Specified by:
    `getKey` in interface `BidiMap`
  Parameters:
    `value` - the value to find the key for
  Returns:
    the mapped key, or `null` if not found

### removeValue

    public java.lang.Object removeValue(java.lang.Object value)

  Description copied from interface: `BidiMap`
  Removes the key-value pair that is currently mapped to the specified value (optional operation).

  If the value is not contained in the map, `null` is returned.

  Implementations should seek to make this method perform equally as well as `remove(Object)`.

  Specified by:
    `removeValue` in interface `BidiMap`
  Parameters:
    `value` - the value to find the key-value pair for
  Returns:
    the key that was removed, `null` if nothing removed

### inverseBidiMap

    public BidiMap inverseBidiMap()

  Description copied from interface: `BidiMap`
  Gets a view of this map where the keys and values are reversed.

  Changes to one map will be visible in the other and vice versa. This enables both directions of the map to be accessed as a `Map`.

  Implementations should seek to avoid creating a new object every time this method is called. See `AbstractMap.values()` etc. Calling this method on the inverse map should return the original.

  Specified by:
    `inverseBidiMap` in interface `BidiMap`
  Returns:
    an inverted bidirectional map

Copyright © 2001-2008 The Apache Software Foundation. All Rights Reserved.